host change
[distro-setup] / btrbk-run
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7
8 # http://www.apache.org/licenses/LICENSE-2.0
9
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17 # todo: if we cancel in the middle of a btrfs send, then run again
18 # immediately, the received subvolume doesn't get a Received UUID:
19 # field, and we won't mount it. Need to figure out a solution that will
20 # fix this.
21
22
23 [[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
24
25 source /usr/local/lib/err
26
27 usage() {
28 cat <<'EOF'
29 btrbk-run [OPTIONS]
30 usually -t TARGET_HOST or -s SOURCE_HOST
31
32 Note, at source location, intentionally not executable, run and read
33 install-my-scripts.
34
35 EOF
36 echo "top of script file:"
37 sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
38 exit $1
39 }
40
41
42
43 pre="${0##*/}: "
44 m() { if $verbose; then printf "$pre%s\n" "$*"; fi; "$@"; }
45 e() { printf "$pre%s\n" "$*"; }
46 die() { printf "$pre%s\n" "$*" >&2; echo "exiting with status 1" >&2; exit 1; }
47 mexit() { echo "$pre: exiting with status $1"; exit $1; }
48
49 # latest $MAIL_HOST
50 if [[ -e /b/bash_unpublished/source-state ]]; then
51 source /b/bash_unpublished/source-state
52 fi
53
54 # note q is owned by root:1000
55
56 mountpoints=()
57
58 rsync_mountpoint=/q
59
60 ret=0
61 # default options
62 conf_only=false
63 dry_run=false # mostly for testing
64 rate_limit=no
65 verbose=true; verbose_arg=-v
66 progress_arg="--progress"
67 incremental_strict=false
68 pull_reexec=false
69
70 default_args_file=/etc/btrbk-run.conf
71 if [[ -s $default_args_file ]]; then
72 set -- $(< $default_args_file) "$@"
73 # i havent used this feature yet, so warn about it
74 echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
75 cat $default_args_file
76 sleep 5
77 fi
78
79 early=false # quit early, just btrbk, no extra remounting etc.
80 cron=false
81 orig_args=("$@")
82 temp=$(getopt -l cron,pull-reexec,help ceil:m:npqs:t:vh "$@") || usage 1
83 eval set -- "$temp"
84 while true; do
85 case $1 in
86 --cron)
87 cron=true
88 pre=
89 shift
90 ;;
91 # only creates the config file, does not run btrbk
92 -c) conf_only=true; shift ;;
93 -e) early=true; shift ;;
94 -i) incremental_strict=true; shift ;;
95 # bytes per second, suffix k m g
96 -l) rate_limit=$2; shift 2 ;;
97 # Comma separated mountpoints to backup. This has defaults set below.
98 -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
99 -n) dry_run=true; dry_run_arg=-n; shift ;;
100 -p) progress_arg="--progress"; shift ;;
101 --pull-reexec) pull_reexec=true; shift ;;
102 -q) verbose=false; verbose_arg=; progress_arg=; shift ;;
103 # source host to receive a backup from
104 -s)
105 source=$2
106 bbksource=$source
107 if [[ $source == *:* ]]; then
108 bbksource="[$source]"
109 fi
110 shift 2
111 ;;
112 # target hosts to send to. empty is valid for just doing local
113 # snapshot. we have default hosts we will populate.
114 -t) IFS=, targets=($2); unset IFS; shift 2 ;;
115 -v) verbose=true; verbose_arg=-v; shift ;;
116 -h|--help) usage ;;
117 --) shift; break ;;
118 *) die "Internal error!" ;;
119 esac
120 done
121
122 # only tested commands are resume and archive
123 cmd_arg=${1:-run}
124
125 case $cmd_arg in
126 run|resume|archive) : ;;
127 *) die "untested command arg" ;;
128 esac
129
130 if (( $# > 1 )); then
131 die: "only 1 nonoption arg is supported"
132 fi
133
134 if [[ -v targets && $source ]]; then
135 # note, this doesnt need to be the case, but
136 # we would need to think about it.
137 die "error: -t and -s are mutually exclusive"
138 fi
139
140 if $verbose; then
141 printf "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
142 fi
143 ### end options parsing
144
145 # remove path from earlier version of btrbk
146 rm -f /usr/sbin/btrbk
147 # note, this still works as intended if there is no /usr/bin/btrbk
148 if [[ /a/opt/btrbk/btrbk -nt /usr/bin/btrbk ]]; then
149 if [[ -e /b/distro-functions/src/package-manager-abstractions ]]; then
150 . /b/distro-functions/src/package-manager-abstractions
151 pi asciidoctor
152 fi
153 cd /a/opt/btrbk
154 m make install
155 fi
156
157 # TODO: i wonder if there should be an option to send to the default
158 # targets, plus any given on the command line.
159
160
161 amy=false
162 # set default targets
163 if [[ ! -v targets && ! $source ]]; then
164 if [[ $HOSTNAME != "$MAIL_HOST" ]] && $cron ; then
165 echo "MAIL_HOST=$MAIL_HOST, nothing to do"
166 mexit 0
167 else
168 amy=true
169 fi
170
171 at_work=false
172
173 targets=(frodo.b8.nz)
174 case $HOSTNAME in
175 kw)
176 at_work=true
177 ;;&
178 x2|x3|sy|bo)
179 if ping -q -c1 -w1 hal.office.fsf.org \
180 && ip n show 192.168.0.26 | grep . &>/dev/null; then
181 at_work=true
182 fi
183 ;;&
184 kw|x2|x3|sy|bo)
185 if $at_work; then
186 if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
187 home=iank.vpn.office.fsf.org
188 else
189 home=i.b8.nz
190 fi
191 else
192 home=b8.nz
193 fi
194 ;;&
195 kw)
196 targets+=($home x3)
197 ;;
198 x2|x3|sy|bo)
199 targets+=($home)
200 if $at_work; then
201 targets+=(kw.office.fsf.org x2.b8.nz)
202 else
203 targets+=(kw.b8.nz)
204 fi
205 ;;
206 kd)
207 targets+=(x2.b8.nz kw.b8.nz)
208 if ping -q -c1 -w1 sy.b8.nz &>/dev/null; then
209 targets+=(sy.b8.nz)
210 else
211 targets+=(syw.b8.nz)
212 fi
213 ;;
214 frodo)
215 # no targets
216 targets=()
217 ;;
218 *)
219 die "error: no default targets for this host, use -t"
220 ;;
221 esac
222 fi
223
224 if [[ -v targets ]]; then
225 echo "targets: ${targets[*]}"
226 fi
227
228 if [[ $source ]]; then
229 echo "source: $source"
230 fi
231
232 if [[ ${mountpoints[0]} ]]; then
233 for mp in ${mountpoints[@]}; do
234 if [[ -e /nocow/btrfs-stale/$mp ]]; then
235 die "error: $mp is stale, mount-latest-subvol first"
236 fi
237 done
238 else
239 # set default mountpoints
240 if [[ ${targets[0]} == tp ]]; then
241 prospective_mps=(/a)
242 else
243 case $HOSTNAME in
244 frodo)
245 prospective_mps=(/i)
246 ;;
247 *)
248 prospective_mps=(/a /q)
249 if [[ $source ]]; then
250 source_state="$(ssh $source cat /a/bin/bash_unpublished/source-state)"
251 eval "$source_state"
252 source_host="$(ssh $source cat /etc/hostname)"
253 if [[ $source_host == "$MAIL_HOST" ]]; then
254 prospective_mps+=(/o)
255 fi
256 else
257 if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
258 # HOST2 is really the mail host if it exists
259 if [[ $HOST2 && $HOST2 != "$HOSTNAME" ]]; then
260 echo "skipping /o because HOST2 is not us"
261 else
262 prospective_mps+=(/o)
263 fi
264 fi
265 fi
266 ;;
267 esac
268 fi
269 for mp in ${prospective_mps[@]}; do # default mountpoints to sync
270 if [[ -e /nocow/btrfs-stale/$mp ]]; then
271 e "warning: $mp stale, not adding to default mountpoints"
272 continue
273 fi
274 if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
275 mountpoints+=($mp)
276 fi
277 done
278 fi
279
280 echo "mountpoints: ${mountpoints[*]}"
281
282 ##### end command line parsing ########
283
284 if [[ $source ]]; then
285 if [[ $(ssh $source ps --no-headers -o comm 1) == systemd ]]; then
286 status=$(ssh $source systemctl is-active btrbk.service) || : # normally returns 3
287 case $status in
288 inactive|failed) : ;;
289 *)
290 echo "$0: error: cron btrbk is running on source. exiting out of caution"
291 mexit 1
292 esac
293 fi
294 fi
295
296 # pull_reexec stops us from getting into an infinite loop if there is some
297 # kind of weird problem
298 pulla=false
299 for m in "${mountpoints[@]}"; do
300 if [[ $m == /a ]]; then
301 pulla=true
302 break
303 fi
304 done
305 if ! $pull_reexec && [[ $source ]] && $pulla ; then
306 tmpf=$(mktemp)
307 m rsync -ra $source:/usr/local/bin/{mount-latest-subvol,check-subvol-stale} /usr/local/bin
308 m rsync -ra $source:/usr/local/lib/err /usr/local/lib
309 m scp $source:/a/bin/distro-setup/btrbk-run $tmpf
310 if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
311 e "found different version on host $source. reexecing"
312 install -T $tmpf /usr/local/bin/btrbk-run
313 m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
314 mexit 0
315 fi
316 fi
317
318
319 if ! which btrbk &>/dev/null; then
320 die "error: no btrbk binary found"
321 fi
322 # if our mountpoints are from stale snapshots,
323 # it doesn't make sense to do a backup.
324 check-subvol-stale ${mountpoints[@]} || die "found stale mountpoints in ${mountpoints[*]}"
325
326 # for an initial run, btrbk requires the dir to exist.
327 mkdir -p /mnt/root/btrbk
328 local_zone=$(date +%z)
329
330 if [[ $source ]]; then
331 if ! zone=$(ssh root@$source date +%z); then
332 die failed to ssh to root@$source
333 fi
334 if [[ $zone != "$local_zone" ]]; then
335 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
336 fi
337
338 else
339
340 sshable=()
341 sshfail=()
342 min_idle_ms=$((1000 * 60 * 15))
343 for h in ${targets[@]}; do
344 if remote_info=( $(timeout -s 9 6 ssh root@$h "mkdir -p /mnt/root/btrbk && date +%z && df --output=size,pcent / | tail -n1") ); then
345 zone=${remote_info[0]}
346 root_size=${remote_info[1]}
347 percent_used=${remote_info[2]%%%}
348
349 if (( ${#remote_info[@]} != 3 )); then
350 die "error: didnt get 3 fields in test ssh to target $h. investigate"
351 fi
352
353
354 # we may be booted into a bootstrap fs or something
355 min_root_kb=$(( 1024 * 1024 * 200 )) # 200 gb
356 if (( root_size < min_root_kb )); then
357 continue
358 fi
359
360 if (( percent_used >= 98 )); then
361 die "error: filesystem on target $h is $percent_used % full"
362 fi
363
364 # This is a separate ssh because xprintidle can fail and thats ok.
365 if $cron && idle_ms=$(timeout -s 9 6 ssh $h DISPLAY=:0 xprintidle); then
366 if (( idle_ms < min_idle_ms )); then
367
368 # Ignore this host. i sometimes use a non-main machine for
369 # testing or web browsing, knowing that everything will be wiped
370 # by the next backup, but I dont want it to happen as Im using
371 # it from cronjob.
372 e "warning: $h: active X session in the last 15 minutes, skipping for now"
373 continue
374 fi
375 fi
376 sshable+=($h)
377 if [[ $zone != "$local_zone" ]]; then
378 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
379 fi
380 else
381 sshfail+=($h)
382 fi
383 done
384 if [[ ! ${sshable[*]} ]] || { ! $cron && [[ ${sshfail[*]} ]]; }; then
385 die "failed to ssh to hosts: ${sshfail[*]}"
386 else
387 if [[ ${sshfail[*]} ]]; then
388 ret=1
389 e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
390 fi
391 targets=(${sshable[@]})
392 fi
393 fi
394
395
396 cat >/etc/btrbk.conf <<EOF
397 ssh_identity /q/root/h
398 #ssh_identity /root/.ssh/home
399
400 # Just a guess that local7 is a good facility to pick.
401 # It's a bit odd that the transaction log has to be logged to
402 # a file or syslog, while other output is sent to std out.
403 # The man does not mention a way for them to be together, but
404 # I dunno if setting a log level like warn might also output
405 # transaction info.
406 transaction_syslog local7
407
408 # trying this out
409 stream_compress zstd
410
411 # so we only run one at a time
412 lockfile /var/lock/btrbk.lock
413
414 # default format of short does not accomidate hourly preservation setting
415 timestamp_format long-iso
416
417 # only make a snapshot if things have changed
418 snapshot_create onchange
419 # I could make this different from target_preserve,
420 # if one disk had less space.
421 # for now, keeping them equal.
422 snapshot_preserve 18h 14d 8w 24m
423 snapshot_preserve_min 2h
424 snapshot_dir btrbk
425
426 # so, total backups = ~58
427 target_preserve 18h 14d 8w 24m
428 target_preserve_min 2h
429
430 # if something fails and it's not obvious, try doing
431 # btrbk -l debug -v dryrun
432
433 rate_limit $rate_limit
434 EOF
435
436 if $incremental_strict; then
437 cat >>/etc/btrbk.conf <<EOF
438 incremental strict
439 EOF
440 fi
441
442 vol=/mnt/root
443 for m in ${mountpoints[@]}; do
444 sub=${m#/}
445 if [[ $source ]]; then
446 cat >>/etc/btrbk.conf <<EOF
447 volume ssh://$bbksource$vol
448 subvolume $sub
449 target send-receive $vol/btrbk
450 EOF
451 fi
452 if (( ${#targets[@]} )); then
453 cat >>/etc/btrbk.conf <<EOF
454 volume $vol
455 subvolume $sub
456 EOF
457 for tg in ${targets[@]}; do
458 # handle ipv6
459 if [[ $tg == *:* ]]; then
460 tg="[$tg]"
461 fi
462 cat >>/etc/btrbk.conf <<EOF
463 target send-receive ssh://$tg$vol/btrbk
464 EOF
465 done
466 fi
467 done
468
469 # if $amy; then
470 # # to manually backup amy,
471 # # bbk -e -s amy -m root_ubuntubionic
472 # cat >>/etc/btrbk.conf <<'EOF'
473 # volume ssh://amy/mnt/root
474 # subvolume root_ubuntubionic
475 # target send-receive /mnt/root/btrbk
476 # EOF
477 # fi
478
479 # todo: umount first to ensure we don't have any errors
480 # todo: do some kill fuser stuff to make umount more reliable
481
482
483 if $conf_only; then
484 mexit 0
485 fi
486
487
488
489 if $dry_run; then
490 m btrbk -v -n $cmd_arg
491 mexit 0
492 elif [[ $cmd_arg == archive ]]; then
493 if [[ $source ]]; then
494 m btrbk $verbose_arg $progress_arg $cmd_arg ssh://$source$vol $vol
495 else
496 for tg in ${targets[@]}; do
497 m btrbk $verbose_arg $progress_arg $cmd_arg $vol ssh://$tg$vol
498 done
499 fi
500 mexit 0
501 fi
502 # -q and just using the syslog option seemed nice,
503 # but it doesn't show when a send has a parent and when it doesn't.
504 m btrbk $verbose_arg $progress_arg $cmd_arg
505
506 # todo: tp not valid anymore.
507 # if we have it, sync to systems which don't
508 if mountpoint $rsync_mountpoint >/dev/null; then
509 for tg in ${targets[@]}; do
510 case $tg in
511 tp)
512 dirs=(/p/c/machine_specific/tp)
513 for x in /p/c/machine_specific/*.hosts; do
514 if grep -qxF $tg $x; then
515 dirs+=(${x%.hosts})
516 fi
517 done
518 m rsync -aSAXPH --specials --devices --delete --relative ${dirs[@]} root@$tg:/
519 ;;
520 esac
521 done
522 fi
523
524 if [[ $source ]]; then
525 m mount-latest-subvol
526 else
527 m /a/exe/mount-latest-remote ${targets[@]}
528 fi
529
530 if [[ $ret == 0 ]]; then
531 for tg in ${targets[@]}; do
532 :
533 #ssh root@$tg /a/exe/mail-backup-clean
534 done
535 fi
536
537 mexit $ret
538
539 # todo: move variable data we don't care about backing up
540 # to /nocow and symlink it.
541
542
543 # background on btrbk timezones. with short/long, timestamps use local time.
544 # for long, if your local time moves backwards, by moving timezones or
545 # for an hour when daylight savings changes it, you will temporarily get
546 # a more aggressive retention policy for the overlapping period, and
547 # vice versa for the opposite timezone move. The alternative is using
548 # long-iso, which puts timezone info into the timestamp, which means
549 # that instead of shifting time, you shift the start of day/week/month
550 # which is used for retention to your new local time, which means for
551 # example, if you moved forward by 8 hours, the daily/weekly/monthly
552 # retention will be 8 hours more aggressive since midnight is at a new
553 # time, unless you fake the timzeone using the TZ env variable.
554 # However, in the short term, there will be no inconsistencies.
555 # I don't see any problem with shifting when the day starts for
556 # retention, so I'm using long-iso.
557
558 # note to create a long-iso timestamp: date +%Y%m%dT%H%M%S%z